------------------------------------------------------
-- gprintf routine                                  --
-- created by: Pete Eberlein (xseal@harborside.com) --
------------------------------------------------------

include image.e
include machine.e

sequence char
char = repeat({}, 256)
global integer charWide, charTall

procedure load_font(integer cWide, integer cTall)
    sequence regs
    integer font_buf, i, on

    regs = repeat(0, 10)
    regs[REG_AX] = #1130
    if cWide = 8 and cTall = 16 then
	regs[REG_BX] = #0600  
    elsif cWide = 8 and cTall = 14 then
	regs[REG_BX] = #0200
    elsif cWide = 8 and cTall = 8 then
	regs[REG_BX] = #0300
    elsif cWide = 9 and cTall = 14 then
	regs[REG_BX] = #0500
    elsif cWide = 9 and cTall = 16 then
	regs[REG_BX] = #0700
    else
	return
    end if
    charWide = cWide
    charTall = cTall
    regs = dos_interrupt(#10, regs)

    font_buf = regs[REG_ES] * #10 + regs[REG_BP]
    for newAscii = 1 to 256 do
	for y = 1 to cTall do
	    i = peek(font_buf + (newAscii)*cTall + y-1)
	    on = 0
	    for x = 1 to 8 do
		if on then
		    if and_bits(i, power(2, 8-x)) then
			char[newAscii][on] = char[newAscii][on] + 1
		    else
			on = 0
		    end if
		elsif and_bits(i, power(2, 8-x)) then
		    char[newAscii] = char[newAscii] & {{x,y}, 1}
		    on = length(char[newAscii])
		end if
	    end for
	end for
    end for
end procedure

global procedure gprintf( sequence pos, integer fColor, integer bColor, 
			  sequence chars )

    integer x, l, dx
    sequence ch, image

    if length(char[1]) = 0 then
	load_font(8,8)
    end if

    image = repeat(repeat(bColor, length(chars) * charWide), charTall)
    if bColor = -1 then
	for i = 1 to length(image) do
	    image[i] = get_pixel((pos + {0,i-1}) & length(image[i]))
	end for
    end if

    dx = 0
    for c = 1 to length(chars) do
	ch = char[chars[c]]
	for i = 1 to length(ch)-1 by 2 do
	    x = ch[i][1] + dx 
	    l = ch[i+1]
	    image[ch[i][2]][x..x+l-1] = repeat(fColor, l)
	end for
	dx = dx + charWide
    end for
    --for i = 1 to length(image) do
	--pixel(pos + {0,i-1}, image[i])
    --end for
    display_image(pos, image)
end procedure
